import { IEquatableObject } from "../equality";
import { IClonable } from "../clone";
export declare class Api implements IEquatableObject<Api>, IClonable<Api> {
    readonly baseURL: string;
    readonly init: RequestInit;
    readonly before: () => void;
    readonly after: () => void;
    constructor(baseURL: string, init: RequestInit, before: () => void, after: () => void);
    /**
     * fetchを実行する
     * @param path baseURLに続くパス
     * @param init fetchのinit
     */
    fetch(path: string, init?: RequestInit): Promise<Response>;
    get(path: string, init?: RequestInit): Promise<Response>;
    post(path: string, init?: RequestInit): Promise<Response>;
    patch(path: string, init?: RequestInit): Promise<Response>;
    put(path: string, init?: RequestInit): Promise<Response>;
    delete(path: string, init?: RequestInit): Promise<Response>;
    create(path: string, init?: RequestInit, before?: () => void, after?: () => void): Api;
    equals(other: Api): boolean;
    get clone(): Api;
    private methodFetch;
    private mergeInit;
    private mergeHeaders;
    private mergeBefore;
    private mergeAfter;
}
export declare function api(args: {
    baseURL?: string;
    init?: RequestInit;
    before?: () => void;
    after?: () => void;
}): Api;
