"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Clonable = void 0;
const iClonable_1 = require("./iClonable");
const hash_1 = require("../hash");
class Clonable extends hash_1.Hashable {
    constructor() {
        super();
    }
    get clone() {
        const copy = Object.create(this);
        this.keys.forEach((key) => {
            const property = this[key];
            if ((0, iClonable_1.isClonable)(property)) {
                copy[key] = property.clone;
                return;
            }
            if (Array.isArray(property)) {
                copy[key] = property.map((value) => {
                    if ((0, iClonable_1.isClonable)(value)) {
                        return value.clone;
                    }
                    return value;
                });
                return;
            }
        });
        return copy;
    }
}
exports.Clonable = Clonable;
//# sourceMappingURL=clonable.js.map