"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Codable = void 0;
const iDecodable_1 = require("./iDecodable");
const update_1 = require("../update");
class Codable extends update_1.Updatable {
    constructor() {
        super();
    }
    get encode() {
        return this;
    }
    decode(json) {
        if (!(typeof json === "object" && json !== null)) {
            throw new Error(`decode object should be an object, but got ${json}`);
        }
        const object = json;
        const clone = this.clone;
        for (const key in object) {
            if (!(key in clone))
                continue;
            clone[key] = (0, iDecodable_1.decode)(object[key], clone[key]);
        }
        return clone;
    }
}
exports.Codable = Codable;
//# sourceMappingURL=codable.js.map