"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const codable_1 = require("./codable");
const assertion_test_1 = require("../equality/assertion.test");
(0, vitest_1.describe)("Codable Tests", () => {
    class A extends codable_1.Codable {
        constructor(name, age) {
            super();
            this.name = name;
            this.age = age;
        }
    }
    class B extends codable_1.Codable {
        constructor(value) {
            super();
            this.value = value;
        }
    }
    class C extends codable_1.Codable {
        constructor(a, b, nums) {
            super();
            this.a = a;
            this.b = b;
            this.nums = nums;
        }
    }
    (0, vitest_1.test)("jsonに変換できる", () => {
        const origin = new C(new A("default", 0), [new B("default")], [1]);
        const json = {
            a: {
                name: "hello",
                age: 10,
            },
            b: [{ value: "bad" }, { value: "good" }],
            nums: [1, 2, 3],
        };
        const expected = new C(new A("hello", 10), [new B("bad"), new B("good")], [1, 2, 3]);
        const actual = origin.decode(json);
        (0, assertion_test_1.assertEquals)(actual, expected);
    });
});
//# sourceMappingURL=codable.test.js.map