"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertNotEquals = exports.assertEquals = void 0;
const vitest_1 = require("vitest");
const equatable_1 = require("./equatable");
/** Equatableの値をassertする */
function assertEquals(actual, expected) {
    (0, vitest_1.expect)(actual.equals(expected), `actual: \n${JSON.stringify(actual)}\nexpected: \n${JSON.stringify(expected)}\n`).toBeTruthy();
}
exports.assertEquals = assertEquals;
/** Equatableの値をassertする */
function assertNotEquals(actual, expected) {
    (0, vitest_1.expect)(actual.equals(expected), `should be not same object but actual: ${String(actual)}`).toBeFalsy();
}
exports.assertNotEquals = assertNotEquals;
(0, vitest_1.describe)("Assertion Tests", function () {
    class Equality extends equatable_1.Equatable {
        constructor(value) {
            super();
            this.value = value;
        }
    }
    (0, vitest_1.test)("assertEquals", () => {
        const actual = new Equality("hello");
        const expected = new Equality("hello");
        assertEquals(actual, expected);
    });
    (0, vitest_1.test)("true", () => {
        const actual = { equals: () => true };
        const expected = { equals: () => false };
        assertEquals(actual, expected);
    });
});
//# sourceMappingURL=assertion.test.js.map