"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.equals = void 0;
const iEquatableObject_1 = require("./iEquatableObject");
function equals(a, b) {
    if (a === b)
        return true;
    if (a == null && b == null)
        return true;
    if (a == null || b == null)
        return false;
    if (Array.isArray(a) && Array.isArray(b)) {
        if (a.length !== b.length)
            return false;
        return a.every((element, index) => equals(element, b[index]));
    }
    if ((0, iEquatableObject_1.isEquatableObject)(a) && (0, iEquatableObject_1.isEquatableObject)(b)) {
        return a.equals(b);
    }
    return false;
}
exports.equals = equals;
//# sourceMappingURL=iEquatable.js.map