"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const iEquatableObject_1 = require("./iEquatableObject");
(0, vitest_1.describe)("isEquatableObject Tests", () => {
    class E {
        equals(other) {
            return false;
        }
    }
    (0, vitest_1.test)("準拠したものならばtrue", () => {
        (0, vitest_1.expect)((0, iEquatableObject_1.isEquatableObject)(new E())).toBeTruthy();
    });
    (0, vitest_1.test)("関数のequalsがあればtrue", () => {
        (0, vitest_1.expect)((0, iEquatableObject_1.isEquatableObject)({ equals: () => true })).toBeTruthy();
    });
    (0, vitest_1.test)("関数以外のequalsがあればfalse", () => {
        (0, vitest_1.expect)((0, iEquatableObject_1.isEquatableObject)({ equals: "hello" })).toBeFalsy();
    });
    (0, vitest_1.test)("nullであればfalse", () => {
        (0, vitest_1.expect)((0, iEquatableObject_1.isEquatableObject)(null)).toBeFalsy();
    });
    (0, vitest_1.test)("objectでなければfalse", () => {
        (0, vitest_1.expect)((0, iEquatableObject_1.isEquatableObject)("hello")).toBeFalsy();
    });
});
//# sourceMappingURL=iEquatableObject.test.js.map