"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const result_for_1 = require("./result-for");
const result_1 = require("../result");
(0, vitest_1.describe)("Result For 5 Tests", () => {
    (0, vitest_1.test)("4つのresult", () => {
        const data = (0, result_1.success)({
            a: (0, result_1.success)({
                b: (0, result_1.success)(3),
                c: (0, result_1.success)("Bob"),
            }),
        });
        const cb = (0, result_for_1.resultFor5)(() => data.map((data) => ({ data })), ({ data }) => data.a.map((a) => ({ a })), ({ a }) => a.b.map((b) => ({ b })), ({ a }) => a.c.map((c) => ({ c }))).yield(({ b, c }) => `${c}は${b}歳`);
        (0, vitest_1.expect)(cb.get).toBe("Bobは3歳");
    });
    (0, vitest_1.test)("5つのfor", () => {
        const config = {
            aOpt: (0, result_1.success)("a"),
            bOpt: (0, result_1.success)("b"),
            cOpt: (0, result_1.success)("c"),
            dOpt: (0, result_1.success)("d"),
            eOpt: (0, result_1.failure)(new Error("error")),
        };
        const result = (0, result_for_1.resultFor5)(() => config.aOpt.map((a) => ({ a })), () => config.bOpt.map((b) => ({ b })), () => config.cOpt.map((c) => ({ c })), () => config.dOpt.map((d) => ({ d })), () => config.eOpt.map((e) => ({ e }))).yield(({ a, b, c, d, e }) => `${a}${b}${c}${d}${e}`);
        (0, vitest_1.expect)(result.getError).toEqual(new Error("error"));
    });
});
//# sourceMappingURL=result-for.test.js.map