"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hash = void 0;
const ts_md5_1 = require("ts-md5");
const iHashableObject_1 = require("./iHashableObject");
function hash(object) {
    if (object == null)
        return ts_md5_1.Md5.hashStr("null");
    if (object instanceof Date)
        return ts_md5_1.Md5.hashStr("Date" + String(object.getTime()));
    if ((0, iHashableObject_1.isHashableObject)(object))
        return object.hashValue;
    if (Array.isArray(object)) {
        return ts_md5_1.Md5.hashStr(object.map(hash).join("array"));
    }
    return ts_md5_1.Md5.hashStr(typeof object + String(object));
}
exports.hash = hash;
//# sourceMappingURL=hash.js.map