"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const hashable_1 = require("./hashable");
(0, vitest_1.describe)("hashable tests", () => {
    class HChild extends hashable_1.Hashable {
        constructor(value) {
            super();
            this.value = value;
        }
    }
    (0, vitest_1.test)("同じ値をハッシュ化すると同じ値になる", () => {
        const h1 = new HChild("hello");
        const h2 = new HChild("hello");
        (0, vitest_1.expect)(h1.hashValue).toBe(h2.hashValue);
    });
    (0, vitest_1.test)("異なる値をハッシュ化すると異なる値になる", () => {
        const h1 = new HChild("hello");
        const h2 = new HChild("world");
        (0, vitest_1.expect)(h1.hashValue === h2.hashValue).toBeFalsy();
    });
    class HParent extends hashable_1.Hashable {
        constructor(value) {
            super();
            this.value = value;
        }
    }
    (0, vitest_1.test)("階層構造でもできる", () => {
        const h1 = new HParent(new HChild("hello"));
        const h2 = new HParent(new HChild("hello"));
        (0, vitest_1.expect)(h1.hashValue).toBe(h2.hashValue);
    });
});
//# sourceMappingURL=hashable.test.js.map