"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const some_1 = require("./some");
const none_1 = require("./none");
const optional_1 = require("./optional");
(0, vitest_1.describe)("Optional Tests", () => {
    (0, vitest_1.test)("nullをoptional型にする", () => {
        const value = null;
        const option = (0, optional_1.optional)(value);
        (0, vitest_1.expect)(option).toBe((0, none_1.none)());
    });
    (0, vitest_1.test)("undefinedをoptional型にする", () => {
        const value = undefined;
        const option = (0, optional_1.optional)(value);
        (0, vitest_1.expect)(option).toBe((0, none_1.none)());
    });
    (0, vitest_1.test)("nullableな型をoptional型にする", () => {
        const option = (0, optional_1.optional)("");
        (0, vitest_1.expect)(option).toEqual((0, some_1.some)(""));
    });
});
//# sourceMappingURL=optional.test.js.map