import { Optional } from "./optional";
import { Result } from "../result";
export declare class Some<T> implements Optional<T> {
    readonly value: T;
    constructor(value: T);
    get get(): T;
    getOrElse(defaultValue: T): T;
    orElse(defaultValue: Optional<T>): Optional<T>;
    readonly isDefined = true;
    readonly isEmpty = false;
    map<U>(f: (value: T) => U): Optional<U>;
    flatMap<U>(f: (value: T) => Optional<U>): Optional<U>;
    equals(compared: Optional<T> | T, comparisonFunc?: (a: T, b: T) => boolean): boolean;
    fold<U>(left: () => U, right: (value: T) => U): U;
    unwrap(_: Error): T;
    toResult<E>(_: E): Result<T, E>;
    get clone(): Some<T>;
    get encode(): unknown;
    decode(json: unknown): Optional<T>;
    compare(compared: Optional<T>): boolean;
    get hashValue(): string;
}
export declare function some<T>(value: T): Some<T>;
