"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.from = exports.OpenRange = void 0;
const update_1 = require("../update");
const range_1 = require("./range");
const closedRange_1 = require("./closedRange");
/** a ... */
class OpenRange extends update_1.Updatable {
    constructor(minimum) {
        super();
        this.minimum = minimum;
    }
    /** 引数の値を含むか */
    contains(value) {
        return this.minimum <= value;
    }
    until(maximum) {
        return new range_1.Range(this.minimum, maximum);
    }
    to(maximum) {
        return new closedRange_1.ClosedRange(this.minimum, maximum);
    }
}
exports.OpenRange = OpenRange;
function from(minimum) {
    return new OpenRange(minimum);
}
exports.from = from;
//# sourceMappingURL=openRange.js.map