"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const openRange_1 = require("./openRange");
const range_1 = require("./range");
const closedRange_1 = require("./closedRange");
(0, vitest_1.describe)("Open Range Tests", () => {
    (0, vitest_1.test)("containsで含むか確認できる", () => {
        const range = (0, openRange_1.from)(4);
        (0, vitest_1.expect)(range.contains(3)).toBeFalsy();
        (0, vitest_1.expect)(range.contains(4)).toBeTruthy();
        (0, vitest_1.expect)(range.contains(5)).toBeTruthy();
    });
    (0, vitest_1.test)("minimumで最小値が取れる", () => {
        const range = (0, openRange_1.from)(4);
        (0, vitest_1.expect)(range.minimum).toBe(4);
    });
    (0, vitest_1.test)("untilでRange型が生成できる", () => {
        const expected = new range_1.Range(4, 6);
        const actual = (0, openRange_1.from)(4).until(6);
        (0, vitest_1.expect)(actual).toEqual(expected);
    });
    (0, vitest_1.test)("toでClosedRange型が生成できる", () => {
        const expected = new closedRange_1.ClosedRange(4, 6);
        const actual = (0, openRange_1.from)(4).to(6);
        (0, vitest_1.expect)(actual).toEqual(expected);
    });
});
//# sourceMappingURL=openRange.test.js.map