"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const success_1 = require("./success");
const result_1 = require("./result");
const failure_1 = require("./failure");
(0, vitest_1.describe)("Result Tests", () => {
    (0, vitest_1.test)("関数をsuccessになおす", () => {
        const expected = (0, success_1.success)(10);
        const actual = (0, result_1.resultBuilder)(() => 10);
        (0, vitest_1.expect)(actual).toEqual(expected);
    });
    (0, vitest_1.test)("関数をfailureになおす", () => {
        const expected = (0, failure_1.failure)(new Error("Hello"));
        const actual = (0, result_1.resultBuilder)(() => {
            throw new Error("Hello");
        });
        (0, vitest_1.expect)(actual).toEqual(expected);
    });
    (0, vitest_1.test)("非同期関数をsuccessになおす", () => __awaiter(void 0, void 0, void 0, function* () {
        const expected = (0, success_1.success)(10);
        const actual = yield (0, result_1.asyncResultBuilder)(() => __awaiter(void 0, void 0, void 0, function* () { return 10; }));
        (0, vitest_1.expect)(actual).toEqual(expected);
    }));
    (0, vitest_1.test)("非同期関数をfailureになおす", () => __awaiter(void 0, void 0, void 0, function* () {
        const expected = (0, failure_1.failure)(new Error("Hello"));
        const actual = yield (0, result_1.asyncResultBuilder)(() => __awaiter(void 0, void 0, void 0, function* () {
            throw new Error("Hello");
        }));
        (0, vitest_1.expect)(actual).toEqual(expected);
    }));
});
//# sourceMappingURL=result.test.js.map