import { Result } from "./result";
import { Some } from "../optional";
export declare class Success<T, E> implements Result<T, E> {
    private readonly value;
    constructor(value: T);
    readonly isSuccess = true;
    readonly isFailure = false;
    get get(): T;
    get getError(): E;
    map<U>(f: (value: T) => U): Result<U, E>;
    flatMap<U>(f: (value: T) => Result<U, E>): Result<U, E>;
    mapError<U>(_: (error: E) => U): Result<T, U>;
    flatMapError<U>(_: (error: E) => Result<T, U>): Result<T, U>;
    equals(compared: Result<T, E>, comparisonFunc?: (a: T, b: T) => boolean, _?: (a: E, b: E) => boolean): boolean;
    get toOptional(): Some<T>;
    get clone(): Result<T, E>;
}
export declare function success<T, E>(value: T): Success<T, E>;
