"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.success = exports.Success = void 0;
const optional_1 = require("../optional");
const equality_1 = require("../equality");
const clone_1 = require("../clone");
class Success {
    constructor(value) {
        this.value = value;
        this.isSuccess = true;
        this.isFailure = false;
    }
    get get() {
        return this.value;
    }
    get getError() {
        throw new Error("success to getError");
    }
    map(f) {
        return success(f(this.value));
    }
    flatMap(f) {
        return f(this.value);
    }
    mapError(_) {
        return this;
    }
    flatMapError(_) {
        return this;
    }
    equals(compared, comparisonFunc, _) {
        if (compared.isFailure)
            return false;
        if (comparisonFunc === undefined) {
            return (0, equality_1.equals)(this.value, compared.get);
        }
        return comparisonFunc(this.value, compared.get);
    }
    get toOptional() {
        return (0, optional_1.some)(this.value);
    }
    get clone() {
        if ((0, clone_1.isClonable)(this.value)) {
            return success(this.value.clone);
        }
        if (typeof this.value === "object") {
            return success(Object.create(this.value));
        }
        return success(this.value);
    }
}
exports.Success = Success;
function success(value) {
    return new Success(value);
}
exports.success = success;
//# sourceMappingURL=success.js.map