"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const updatable_1 = require("./updatable");
(0, vitest_1.describe)("Updatable Tests", () => {
    class Human extends updatable_1.Updatable {
        constructor(name, age) {
            super();
            this.name = name;
            this.age = age;
        }
    }
    (0, vitest_1.test)("updateメソッドで浅い更新ができ、元のオブジェクトに影響しない", () => {
        const human = new Human("Taro", 20);
        const updatedHuman = human.update({
            name: "Jiro",
        });
        (0, vitest_1.expect)(updatedHuman.name).toBe("Jiro");
        (0, vitest_1.expect)(updatedHuman.age).toBe(20);
        (0, vitest_1.expect)(human.name).toEqual("Taro");
    });
});
//# sourceMappingURL=updatable.test.js.map